/* -*- mode: js2; js2-basic-offset: 4; indent-tabs-mode: nil -*- */
/*

    Copyright (C) 2012-2014  Dieter Schärf <ds@dschaerf.de>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program. If not, see <http://www.gnu.org/licenses/>.

 */

const Lang = imports.lang;

const ExtensionUtils = imports.misc.extensionUtils;

const Main = imports.ui.main;

const Extension = ExtensionUtils.getCurrentExtension();

const Convenience = Extension.imports.convenience;

/*
    PanelManager - DateMenu
 */
const KEY_SHOW_DATEMENU = 'show-datemenu';

const DateMenu = new Lang.Class({
    Name: 'DateMenu',

    _init: function() {
        this._settings = Convenience.getSettings(Convenience.CURRENT_SETTINGS_SCHEMA);
        this._connectSettings = this._settings.connect('changed::'+KEY_SHOW_DATEMENU, Lang.bind(this, this._onShowDateMenu));
        this._onShowDateMenu();
    },

    _onShowDateMenu: function(enable) {
        this._updateVisibility(this._settings.get_boolean(KEY_SHOW_DATEMENU));
    },

    _updateVisibility: function(visible) {
        if (Main.panel._dateMenu) {
            Main.panel._dateMenu.actor.visible = visible;
        } else {
            Main.panel.statusArea.dateMenu.container.visible = visible;
        }
    },

    destroy: function() {
        this._settings.disconnect(this._connectSettings);
        this._updateVisibility(true);
    }
});

function getExtension() {
    return new DateMenu();
}
